From bc46f0fa8c80a3a376cde8489fb949a02b328371 Mon Sep 17 00:00:00 2001
From: Steve Klabnik <steve@steveklabnik.com>
Date: Tue, 10 Sep 2013 13:14:40 -0700
Subject: [PATCH] Nodoc large parts of rss

---
 lib/rss/0.9.rb  |   10 +++++-----
 lib/rss/1.0.rb  |   10 +++++-----
 lib/rss/2.0.rb  |    2 +-
 lib/rss/atom.rb |   30 ++++++++++++------------------
 4 files changed, 23 insertions(+), 29 deletions(-)

diff --git a/lib/rss/0.9.rb b/lib/rss/0.9.rb
index 77b2de1..0e28098 100644
--- a/lib/rss/0.9.rb
+++ b/lib/rss/0.9.rb
@@ -36,17 +36,17 @@ module RSS
   # RSS 0.9 feed with one item. If we needed a second item, we'd make another
   # block with maker.items.new_item and build a second one.
   module RSS09
-    NSPOOL = {}
-    ELEMENTS = []
+    NSPOOL = {} # :nodoc:
+    ELEMENTS = [] # :nodoc:
 
-    def self.append_features(klass)
+    def self.append_features(klass) # :nodoc:
       super
 
       klass.install_must_call_validator('', "")
     end
   end
 
-  class Rss < Element
+  class Rss < Element # :nodoc: all
 
     include RSS09
     include RootElementMixin
@@ -184,7 +184,7 @@ module RSS
 
       end
 
-      class SkipHours < Element
+      class SkipHours < Element # :nodoc: all
         include RSS09
 
         [
diff --git a/lib/rss/1.0.rb b/lib/rss/1.0.rb
index a2d88d4..cca7258 100644
--- a/lib/rss/1.0.rb
+++ b/lib/rss/1.0.rb
@@ -35,10 +35,10 @@ module RSS
   # RSS 1.0 feed with one item. If we needed a second item, we'd make another
   # block with maker.items.new_item and build a second one.
   module RSS10
-    NSPOOL = {}
-    ELEMENTS = []
+    NSPOOL = {} # :nodoc:
+    ELEMENTS = [] # :nodoc:
 
-    def self.append_features(klass)
+    def self.append_features(klass) # :nodoc:
       super
 
       klass.install_must_call_validator('', ::RSS::URI)
@@ -46,7 +46,7 @@ module RSS
 
   end
 
-  class RDF < Element
+  class RDF < Element # :nodoc: all
 
     include RSS10
     include RootElementMixin
@@ -465,7 +465,7 @@ module RSS
     BaseListener.install_get_text_element(URI, name, name)
   end
 
-  module ListenerMixin
+  module ListenerMixin # :nodoc: all
     private
     def initial_start_RDF(tag_name, prefix, attrs, ns)
       check_ns(tag_name, prefix, ns, RDF::URI, false)
diff --git a/lib/rss/2.0.rb b/lib/rss/2.0.rb
index 5c0caec..11aa395 100644
--- a/lib/rss/2.0.rb
+++ b/lib/rss/2.0.rb
@@ -35,7 +35,7 @@ module RSS
   # block with maker.items.new_item and build a second one.
   class Rss
 
-    class Channel
+    class Channel # :nodoc: all
 
       [
         ["generator"],
diff --git a/lib/rss/atom.rb b/lib/rss/atom.rb
index d352423..0efadeb 100644
--- a/lib/rss/atom.rb
+++ b/lib/rss/atom.rb
@@ -11,17 +11,11 @@ module RSS
   # See the RSS module for examples consuming and creating feeds.
   module Atom
 
-    ##
-    # The Atom URI W3C Namespace
+    URI = "http://www.w3.org/2005/Atom" # :nodoc:
 
-    URI = "http://www.w3.org/2005/Atom"
+    XHTML_URI = "http://www.w3.org/1999/xhtml" # :nodoc:
 
-    ##
-    # The XHTML URI W3C Namespace
-
-    XHTML_URI = "http://www.w3.org/1999/xhtml"
-
-    module CommonModel
+    module CommonModel # :nodoc: all
       NSPOOL = {}
       ELEMENTS = []
 
@@ -48,7 +42,7 @@ module RSS
       end
     end
 
-    module ContentModel
+    module ContentModel  # :nodoc: all
       module ClassMethods
         def content_type
           @content_type ||= nil
@@ -78,7 +72,7 @@ module RSS
       end
     end
 
-    module URIContentModel
+    module URIContentModel  # :nodoc: all
       class  << self
         def append_features(klass)
           super
@@ -94,7 +88,7 @@ module RSS
     # which is used to store small quantities of human-readable text
     #
     # The TextConstruct has a type attribute, e.g. text, html, xhtml
-    module TextConstruct
+    module TextConstruct  # :nodoc: all
       def self.append_features(klass)
         super
         klass.class_eval do
@@ -166,7 +160,7 @@ module RSS
     # used to describe a person, corporation, or similar entity
     #
     # The PersonConstruct has a Name, Uri, and Email child elements
-    module PersonConstruct
+    module PersonConstruct  # :nodoc: all
 
       # Adds attributes for name, uri, and email to the +klass+
       def self.append_features(klass)
@@ -210,7 +204,7 @@ module RSS
     # Examples:
     # * 2013-03-04T15:30:02Z
     # * 2013-03-04T10:30:02-05:00
-    module DateConstruct
+    module DateConstruct  # :nodoc: all
       def self.append_features(klass)
         super
         klass.class_eval do
@@ -225,7 +219,7 @@ module RSS
       end
     end
 
-    module DuplicateLinkChecker
+    module DuplicateLinkChecker # :nodoc: all
       # Checks if there are duplicate links with the same type and hreflang attributes
       # that have an alternate (or empty) rel attribute
       #
@@ -247,7 +241,7 @@ module RSS
     # Atom feed element
     #
     # A Feed has several metadata attributes in addition to a number of Entry child elements
-    class Feed < RSS::Element
+    class Feed < RSS::Element  # :nodoc: all
       include RootElementMixin
       include CommonModel
       include DuplicateLinkChecker
@@ -721,7 +715,7 @@ module RSS
 
     # Defines a top-level Atom Entry element
     #
-    class Entry < RSS::Element
+    class Entry < RSS::Element # :nodoc: all
       include RootElementMixin
       include CommonModel
       include DuplicateLinkChecker
@@ -804,7 +798,7 @@ module RSS
     BaseListener.install_get_text_element(Atom::URI, name, "#{name}=")
   end
 
-  module ListenerMixin
+  module ListenerMixin # :nodoc: all
     private
     def initial_start_feed(tag_name, prefix, attrs, ns)
       check_ns(tag_name, prefix, ns, Atom::URI, false)
-- 
1.7.10.4